/*
 *                     The OCaml-gtk interface
 *
 * Copyright (c) 1997, 1998   David Monniaux & Pascal Cuoq
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * [see the file COPYING.LIB]
 */

/* $Id: mlglib_stub.c,v 1.3 1998/11/20 10:40:19 monniaux Exp $ */

#include <glib.h>
#include <caml/mlvalues.h>

value mlg_list_free(value list)
{
  g_list_free((GList*) list);
  return Val_unit;
}

value mlg_list_free_1(value list)
{
  g_list_free_1((GList*) list);
  return Val_unit;
}

value mlg_list_insert(value list, value item, value index)
{
  return (value)
    g_list_insert((GList*) list, (gpointer) item, Int_val(index));
}

value mlg_list_nth(value list, value item)
{
  return (value) g_list_nth((GList*) list, Int_val(item));
}

value mlg_list_length(value list)
{
  return Val_int(g_list_length((GList*) list));
}

value mlg_slist_free(value list)
{
  g_slist_free((GSList*) list);
  return Val_unit;
}

value mlg_slist_free_1(value list)
{
  g_slist_free_1((GSList*) list);
  return Val_unit;
}

value mlg_slist_insert(value list, value item, value index)
{
  return (value)
    g_slist_insert((GSList*) list, (gpointer) item, Int_val(index));
}

value mlg_slist_nth(value list, value item)
{
  return (value) g_slist_nth((GSList*) list, Int_val(item));
}

value mlg_slist_length(value list)
{
  return Val_int(g_slist_length((GSList*) list));
}

void mlglib_callback_exec(value x, value closure)
{
  callback(closure, x);
}

value mlg_list_foreach(value list, value func)
{
  g_list_foreach((GList*) list, 
    (GFunc) mlglib_callback_exec, (gpointer) func);
}

value mlg_slist_foreach(value list, value func)
{
  g_slist_foreach((GSList*) list,
    (GFunc) mlglib_callback_exec, (gpointer) func);
}

value mlg_zero(value dummy)
{
  return 0;
}
